image: docker:latest
services:
- docker:dind

stages:
- build
- test
- release

variables:
  TEST_IMAGE: $CI_REGISTRY_IMAGE:${PHPUNIT_VERSION}-php${PHP_VERSION}
  RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest


before_script:
  - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN $CI_REGISTRY

build:
  stage: build
  script:
    - docker build --pull --build-arg PHP_VERSION=${PHP_VERSION} --build-arg PHPUNIT_VERSION=${PHPUNIT_VERSION} -t $TEST_IMAGE .
    - docker push $TEST_IMAGE
  only:
    - web

test:
  stage: test
  script:
    - docker pull $TEST_IMAGE
    - docker run $TEST_IMAGE --check-version
  only:
    - web

release:
  stage: release
  script:
    - docker pull $TEST_IMAGE
    - docker tag $TEST_IMAGE $RELEASE_IMAGE
    - docker push $RELEASE_IMAGE
  only:
    - web